// regdllDlg.cpp : implementation file
//

#include "stdafx.h"
#include "regdll.h"
#include "regdllDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRegdllDlg dialog

CRegdllDlg::CRegdllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegdllDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegdllDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRegdllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegdllDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRegdllDlg, CDialog)
	//{{AFX_MSG_MAP(CRegdllDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_DOITNOW, OnDoitnow)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegdllDlg message handlers

BOOL CRegdllDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CheckDlgButton (IDC_RADIO1, TRUE) ;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRegdllDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRegdllDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRegdllDlg::OnBrowse() 
{
	CFileDialog dlg (TRUE) ;
	
	if (dlg.DoModal( ))
	{
		CString str = dlg.GetPathName( ) ;
		SetDlgItemText (IDC_EDIT1, (LPCTSTR) str) ;
	}
}

void CRegdllDlg::OnDoitnow() 
{
	char FileName [256] ;
	GetDlgItemText (IDC_EDIT1, FileName, sizeof(FileName)) ;

	HINSTANCE hLib = LoadLibrary (FileName) ;

	if (!hLib)
	{
		AfxMessageBox ("Specified file could not be loaded.") ;
		return ;
	}


	FARPROC pRegisterProc ;

	if (IsDlgButtonChecked (IDC_RADIO1))
	{
		pRegisterProc = GetProcAddress (hLib, "DllRegisterServer") ;

		if (!pRegisterProc)
		{
			AfxMessageBox ("Specified DLL does not export the function DllRegisterServer( )") ;
			return ;
		}
	
		if ((*pRegisterProc) ( ) == S_OK)
		{
			AfxMessageBox ("DLL server successfully registered") ;
		}
		else
		{
			AfxMessageBox ("DLL attempted to register itself but was unable to") ;
		}
	}

	else
	{
		pRegisterProc = GetProcAddress (hLib, "DllUnregisterServer") ;

		if (!pRegisterProc)
		{
			AfxMessageBox ("Specified DLL does not export the function DllUnregisterServer( )") ;
			return ;
		}
		if ((*pRegisterProc) ( ) == S_OK)
		{
			AfxMessageBox ("DLL server successfully unregistered") ;
		}
		else
		{
			AfxMessageBox ("DLL attempted to unregister itself but was unable to") ;
		}
	}

	FreeLibrary (hLib) ;
}
